#include "chip.h"
#include <stdlib.h>

typedef struct {
    int id;
    __IO uint32_t *clk_reg;
    uint32_t clk_msk;
    __IO uint32_t *rst_reg;
    uint32_t rst_msk;
} t_per_regs;


static const t_per_regs f_per_regs[] = {
    {CHIP_PER_ID_DMA1,      &CHIP_REGS_RCC->AHBENR,    CHIP_REGFLD_RCC_AHBENR_DMA1_EN,      NULL,                       0},
    {CHIP_PER_ID_DMA2,      &CHIP_REGS_RCC->AHBENR,    CHIP_REGFLD_RCC_AHBENR_DMA2_EN,      NULL,                       0},
    {CHIP_PER_ID_SRAM,      &CHIP_REGS_RCC->AHBENR,    CHIP_REGFLD_RCC_AHBENR_SRAM_EN,      NULL,                       0},
    {CHIP_PER_ID_FLASH,     &CHIP_REGS_RCC->AHBENR,    CHIP_REGFLD_RCC_AHBENR_FLITF_EN,     NULL,                       0},
    {CHIP_PER_ID_CRC,       &CHIP_REGS_RCC->AHBENR,    CHIP_REGFLD_RCC_AHBENR_CRC_EN,       NULL,                       0},
    {CHIP_PER_ID_GPIOA,     &CHIP_REGS_RCC->AHBENR,    CHIP_REGFLD_RCC_AHBENR_IOPA_EN,      NULL,                       0},
    {CHIP_PER_ID_GPIOB,     &CHIP_REGS_RCC->AHBENR,    CHIP_REGFLD_RCC_AHBENR_IOPB_EN,      NULL,                       0},
    {CHIP_PER_ID_GPIOC,     &CHIP_REGS_RCC->AHBENR,    CHIP_REGFLD_RCC_AHBENR_IOPC_EN,      NULL,                       0},
    {CHIP_PER_ID_GPIOD,     &CHIP_REGS_RCC->AHBENR,    CHIP_REGFLD_RCC_AHBENR_IOPD_EN,      NULL,                       0},
    {CHIP_PER_ID_GPIOE,     &CHIP_REGS_RCC->AHBENR,    CHIP_REGFLD_RCC_AHBENR_IOPE_EN,      NULL,                       0},
    {CHIP_PER_ID_GPIOF,     &CHIP_REGS_RCC->AHBENR,    CHIP_REGFLD_RCC_AHBENR_IOPF_EN,      NULL,                       0},
    {CHIP_PER_ID_CRS,       &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_CRS_EN,      &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_CRS_RST},
    {CHIP_PER_ID_PWR,       &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_PWR_EN,      &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_PWR_RST},
    {CHIP_PER_ID_DBG,       &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_DBGMCU_EN,   &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_DBGMCU_RST},
    {CHIP_PER_ID_WWDG,      &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_WWDG_EN,     &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_WWDG_RST},
    {CHIP_PER_ID_TIM1,      &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_TIM1_EN,     &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_TIM1_RST},
    {CHIP_PER_ID_TIM2,      &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_TIM2_EN,     &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_TIM2_RST},
    {CHIP_PER_ID_TIM3,      &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_TIM3_EN,     &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_TIM3_RST},
    {CHIP_PER_ID_TIM6,      &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_TIM6_EN,     &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_TIM6_RST},
    {CHIP_PER_ID_TIM7,      &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_TIM7_EN,     &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_TIM7_RST},
    {CHIP_PER_ID_TIM14,     &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_TIM14_EN,    &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_TIM14_RST},
    {CHIP_PER_ID_TIM15,     &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_TIM15_EN,    &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_TIM15_RST},
    {CHIP_PER_ID_TIM16,     &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_TIM16_EN,    &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_TIM16_RST},
    {CHIP_PER_ID_TIM17,     &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_TIM17_EN,    &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_TIM17_RST},
    {CHIP_PER_ID_USART1,    &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_USART1_EN,   &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_USART1_RST},
    {CHIP_PER_ID_USART2,    &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_USART2_EN,   &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_USART2_RST},
    {CHIP_PER_ID_USART3,    &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_USART3_EN,   &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_USART3_RST},
    {CHIP_PER_ID_USART4,    &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_USART4_EN,   &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_USART4_RST},
    {CHIP_PER_ID_USART5,    &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_USART5_EN,   &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_USART5_RST},
    {CHIP_PER_ID_USART6,    &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_USART6_EN,   &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_USART6_RST},
    {CHIP_PER_ID_USART7,    &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_USART7_EN,   &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_USART7_RST},
    {CHIP_PER_ID_USART8,    &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_USART8_EN,   &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_USART8_RST},
    {CHIP_PER_ID_SPI1,      &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_SPI1_EN,     &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_SPI1_RST},
    {CHIP_PER_ID_SPI2,      &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_SPI2_EN,     &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_SPI2_RST},
    {CHIP_PER_ID_I2C1,      &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_I2C1_EN,     &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_I2C1_RST},
    {CHIP_PER_ID_I2C2,      &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_I2C2_EN,     &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_I2C2_RST},
    {CHIP_PER_ID_USB,       &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_USB_EN,      &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_USB_RST},
    {CHIP_PER_ID_CAN,       &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_CAN_EN,      &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_CAN_RST},
    {CHIP_PER_ID_ADC,       &CHIP_REGS_RCC->APB2ENR,   CHIP_REGFLD_RCC_APB2ENR_ADC_EN,      &CHIP_REGS_RCC->APB2RSTR,   CHIP_REGFLD_RCC_APB2RSTR_ADC_RST},
    {CHIP_PER_ID_DAC,       &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_DAC_EN,      &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_DAC_RST},
    {CHIP_PER_ID_CEC,       &CHIP_REGS_RCC->APB1ENR,   CHIP_REGFLD_RCC_APB1ENR_CEC_EN,      &CHIP_REGS_RCC->APB1RSTR,   CHIP_REGFLD_RCC_APB1RSTR_CEC_RST},
    {CHIP_PER_ID_TSC,       &CHIP_REGS_RCC->AHBENR,   CHIP_REGFLD_RCC_AHBENR_TSC_EN,        NULL,                       0},
};

static const t_per_regs *get_per_regs(int id) {
    const t_per_regs *ret = 0;
    for (unsigned i = 0; i < sizeof(f_per_regs)/sizeof(f_per_regs[0]); i++) {
        if (f_per_regs[i].id == id) {
            ret = &f_per_regs[i];
            break;
        }
    }
    return ret;
}

void chip_per_rst(int per_id) {
    const t_per_regs *reg = get_per_regs(per_id);
    if (reg && reg->rst_reg) {
        *reg->rst_reg |= reg->rst_msk;
        chip_dmb();
        *reg->rst_reg &= ~reg->rst_msk;
        chip_dsb();
    }
}

void chip_per_clk_en(int per_id) {
    const t_per_regs *reg = get_per_regs(per_id);
    if (reg && reg->clk_reg) {
        *reg->clk_reg |= reg->clk_msk;
    }
}

void chip_per_clk_dis(int per_id) {
    const t_per_regs *reg = get_per_regs(per_id);
    if (reg && reg->clk_reg) {
        *reg->clk_reg &= ~reg->clk_msk;
    }
}

bool chip_per_clk_is_en(int per_id) {
    const t_per_regs *reg = get_per_regs(per_id);
    return  reg && reg->clk_reg && ((*reg->clk_reg & reg->clk_msk) != 0);
}
